ServerCallbacks = {}
CurrentRequestId = 0
vRP = Proxy.getInterface("vRP")

vRPSgarage = {}
Tunnel.bindInterface("Dream_garages", vRPSgarage)
Proxy.addInterface("Dream_garages", vRPSgarage)
vRPSgarage = Tunnel.getInterface("Dream_garages", "Dream_garages")

local config = module(GetCurrentResourceName(), "config")
local garages = config.garages
local garage_types = config.garage_types

function TriggerServerCallback(name, cb, ...)
    ServerCallbacks[CurrentRequestId] = cb
    TriggerServerEvent(GetCurrentResourceName() .. ":triggerServerCallback", name, CurrentRequestId, ...)
    if CurrentRequestId < 65535 then
        CurrentRequestId = CurrentRequestId + 1
    else
        CurrentRequestId = 0
    end
end

RegisterNetEvent(GetCurrentResourceName() .. ":serverCallback")
AddEventHandler(
    GetCurrentResourceName() .. ":serverCallback",
    function(requestId, ...)
        ServerCallbacks[requestId](...)
        ServerCallbacks[requestId] = nil
    end
)

local textui = {}
for k, v in pairs(garages) do
    textui[k] = false
    if garage_types[v[1]] ~= nil then
        vRP.addBlip({ v[2], v[3], v[4], garage_types[v[1]]._config.blipid, garage_types[v[1]]._config.blipcolor, v[1] })
    end
end

CreateThread(function()
    Wait(500)
    local ticks = 1000
    while true do
        for k, v in pairs(garages) do
            if #(vector3(v[2], v[3], v[4]) - GetEntityCoords(PlayerPedId())) < 3.5 then
                ticks = 1
                DrawMarker(
                    36, -- Tipul markerului
                    v[2], -- Coordonata X
                    v[3], -- Coordonata Y
                    v[4] - 0.3, -- Coordonata Z
                    0, 0, 0, -- Offset și rotație
                    0, 0, 0, -- Dimensiuni
                    0.8001, 0.8001, 1.0001, -- Scale
                    0, 191, 255, 100, -- Culoare (albastru deschis cu transparență)
                    false, -- Marker ne-rotativ
                    0, -- Textură
                    0, -- DrawOnEnts
                    true -- Se desenează dinamic
                )
                             if #(vector3(v[2], v[3], v[4]) - GetEntityCoords(PlayerPedId())) < 1.5 then
                    if not textui[k] then
                        exports["s_ui"]:Open("[E] Acceseaza garajul", "lightblue", "left")
                        textui[k] = true
                    end
                    if IsControlJustPressed(0, 38) then
                        exports["s_ui"]:Close()
                        if v[1] == "Civil" then
                            TriggerServerCallback(
                                "getuvehs",
                                function(vehs)
                                    DisplayRadar(false)
                                    tabelmasini = {}
                                    local id = 1
                                    for k1, v1 in pairs(vehs) do
                                        -- Verifică dacă vehiculul face parte din lista "cars" a garajului Civil
                                        if garage_types[v[1]].cars[v1.vehicle] then
                                            local speed = math.ceil(GetVehicleModelEstimatedMaxSpeed(v1.vehicle) * 5)
                                            tabelmasini[#tabelmasini + 1] =
                                            {
                                                model = v1.vehicle,
                                                odometer = speed,
                                                plate = v1.vehicle_plate,
                                                name = garage_types[v[1]].cars[v1.vehicle],
                                                id = 1,
                                                favorite = 0,
                                                veh_type = v.veh_type,
                                            }
                                            id = id + 1
                                        end
                                    end                                    
                                    open_garage(v[1], tabelmasini)
                                end
                            )
                        end
                    end
                else
                    if textui[k] then
                        exports["s_ui"]:Close()
                        textui[k] = false
                        ticks = 1000
                    end
                end
            end
        end
        Wait(ticks)
    end
end)

CreateThread(function()
    Wait(500)
    local ticks = 1000
    local markerVisible = false  -- Variabilă pentru a controla vizibilitatea markerului
    while true do
        local playerCoords = GetEntityCoords(PlayerPedId())
        local isNearGarage = false

        for k, v in pairs(garages) do
            if #(vector3(v[2], v[3], v[4]) - playerCoords) < 3.5 then
                ticks = 0
                isNearGarage = true

                if not markerVisible then
                    markerVisible = true  -- Setează markerul ca vizibil
                end

                DrawMarker(
                    23,
                    v[2], v[3], v[4] - 1.0,
                    0, 0, 0,
                    0, 0, 0,
                    2.5, 2.5, 1.0,  -- Dimensiune mai mare pentru marker
                    255, 255, 255, 80,
                    false, true, 2, false, nil, nil, false
                )

                if #(vector3(v[2], v[3], v[4]) - playerCoords) < 1.5 then
                    if not textui[k] then
                        textui[k] = true
                    end
                end
            else
                if markerVisible then
                    markerVisible = false  -- Setează markerul ca invizibil
                end
            end
        end

        -- Dacă ești aproape de un garaj, așteaptă 1 milisecundă, altfel așteaptă 1000 de milisecunde
        if isNearGarage then
            ticks = 1
        else
            ticks = 1000
        end

        Wait(ticks)
    end
end)

function open_garage(name, vehicles, vehsToBuy)
    if type(name) ~= "string" then return end
    if type(vehicles) ~= "table" then return end
    -- Eliminat print-urile
    inGarage = true
    SetPlayerControl(PlayerId(), 256, false)
    SetNuiFocus(inGarage, inGarage)
    DisplayRadar(not inGarage)
    local tbl = {}

    if vehsToBuy then
        tbl = vehsToBuy
    else
        tbl = {}
    end

    SendNUIMessage {
        action = "open_garage",
        garage_name = name,
        vehicles = vehicles,
        vehsToBuy = tbl
    }
end


function close_garage()
    inGarage = false
    SetPlayerControl(PlayerId(), 256, true)
    SetNuiFocus(inGarage, inGarage)
    DisplayRadar(not inGarage)

    storedData = {}

    SendNUIMessage {
        action = "close_garage"
    }
end

RegisterNetEvent("machiamavlad:open_garage", open_garage)
RegisterNetEvent("machiamavlad:close_garage", close_garage)
RegisterNUICallback("close_garages", function(data, cb)
    close_garage()
end)

RegisterNUICallback("park_vehicle", function(data, cb)
    if not inGarage then return end

    close_garage()
    vRP.despawnGarageVehicle({ data.veh_type, 5.0 })
end)

RegisterNUICallback("buy_garage_vehicle", function(data, cb)
    if not inGarage then return end

    close_garage()
    TriggerServerEvent("machiamavlad:tryBuyGarageVehicle", data.model)
end)

RegisterNUICallback("spawn_vehicle", function(data, cb)
    if not inGarage then return end

    close_garage()
    vRP.spawnGarageVehicle({ data.veh_type, data.veh, data.plate })
end)

RegisterNUICallback("saveFavVehicle", function(data, cb)
    if not inGarage then return end

    TriggerServerEvent("machiamavlad:trySetFavVehicle", data.vehId, data.favorite)
end)
